<?php

namespace App\Controllers;

class Roles extends BaseController{

    public function __construct()  
    { 
        $this->db = \Config\Database::connect(); 
          
    } 

public function add_roles(){
$role_name=$this->request->getpost('role_name');
$remarks=$this->request->getpost('remarks');
$created_at=date('y-m-d H-i-s');
$created_by = session()->get('username');
$data=[
    "role"=>$role_name,
    'remarks'=>$remarks,
    'created_at'=>$created_at,
   'created_by'=>$created_by,

];

try {
    $builder=$this->db->table('roles');
    if($builder->insert($data)){

        return $this->response->setJSON(['result'=>1,'message'=>'Role Add successfully']);
    }else{

        return $this->response->setJSON(['result'=>0,'message'=>'Failed Create Role']);
    }

}catch(\Exception $e){
    return $this->response->setJSON(['result' => 0, 'message' => $e->getMessage()]);
}

}

public function fetch_roles(){

    $db = \Config\Database::connect();
    $builder = $db->table('roles'); 
    $builder->select('id ,role,role_name'); 
    $query = $builder->get();
    $role = $query->getResultArray();

    if ($role) {
        return $this->response->setJSON($role);
    } else {
        return $this->response->setJSON(['result' => 0, 'message' => 'No headers found']);
    }
}

public function add_roles_creation()
{
    $role_name = $this->request->getPost('role');
    $apm = $this->request->getPost('apm');
    $supervisor = $this->request->getPost('supervisor');
    $firstname = $this->request->getPost('First_Name');
    $lastname = $this->request->getPost('Last_Name');
    $phoneNo = $this->request->getPost('Phone_Number');
    $email = $this->request->getPost('E-Mail');
    $dob = $this->request->getPost('dob');
    $gender = $this->request->getPost('gender');
    $department = $this->request->getPost('department');
    $DOJ = $this->request->getPost('doj');
    $pan_no = $this->request->getPost('Pan_Number');
    $address = $this->request->getPost('Address');
    $status = $this->request->getPost('status');
     date_default_timezone_set('Asia/Kolkata');
    $created_at = date('Y-m-d H:i:s'); 
    $created_by = session()->get('username');

   
    $file = $this->request->getFile('file');
    $newname = null;  

    if ($file && $file->isValid() && !$file->hasMoved()) {
        $newname = $file->getRandomName();
        $file->move(ROOTPATH . 'public/employeeImages', $newname);
    }

  
    $password = bin2hex(random_bytes(4)); 

   
    $data = [
        'role' => $role_name,
        'created_at' => $created_at,
        'created_by' => $created_by,
        'first_name' => $firstname,
        'last_name' => $lastname,
        'phone_no' => $phoneNo,
        'email' => $email,
        'dob' => $dob,
        'gender' => $gender,
        'department' => $department,
        'date_of_joining' => $DOJ,
        'pan_no' => $pan_no,
        'address' => $address,
        'status' => $status
    ];

   
    if (!empty($newname)) {
        $data['upload_photo'] = $newname;
    }

    if (!empty($apm)) {
        $data['apm'] = $apm;
    }
    if (!empty($supervisor)) {
        $data['supervisor'] = $supervisor;
    }

    try {
        $builder = $this->db->table('roles_creation');
        if ($builder->insert($data)) {
            // Send email with generated password
            $this->sendEmail($email, $password);

            // Insert into users table
            $user_data = [
                'username' => $firstname,
                'email' => $email,
                'password' => $password,
                'role' => $role_name,
                'valid_user' => 1,
                'created_at' => $created_at,
                'created_by' => $created_by,
            ];

            $user_builder = $this->db->table('users');
            if ($user_builder->insert($user_data)) {
                return $this->response->setJSON(['result' => 1, 'message' => 'Role added and user created successfully.']);
            } else {
                return $this->response->setJSON(['result' => 0, 'message' => 'Failed to create user.']);
            }
        } else {
            return $this->response->setJSON(['result' => 0, 'message' => 'Failed to create role.']);
        }
    } catch (\Exception $e) {
        return $this->response->setJSON(['result' => 0, 'message' => $e->getMessage()]);
    }
}


public function sendEmail($email, $password) {
    $email_service = \Config\Services::email();

    $email_service->setTo($email);
    $email_service->setSubject('Your Account Details - Nirmithi Kendra');
    $email_service->setMessage("Dear User,\n\nYour account has been successfully created in Nirmithi Kendra.\n\nHere are your login credentials:\n\nEmail: $email\nPassword: $password\n\nPlease keep this information safe and use it to access your account.\n\nThank you,\nNirmithi Kendra Team.");

    if ($email_service->send()) {
        return true;
    } else {
        log_message('error', $email_service->printDebugger());
        return false;
    }
}


public function fetch_admin() {
    $db = \Config\Database::connect();
    $builder = $db->table('roles_creation'); 
    $builder->select('id, first_name,role');
    $builder->where('role', '1');
    
    $query = $builder->get();
    $role = $query->getResultArray();

    if ($role) {
        return $this->response->setJSON($role);
    } else {
        return $this->response->setJSON(['result' => 0, 'message' => 'No roles found']);
    }
}


public function fetch_apm() {
    $db = \Config\Database::connect();
    $builder = $db->table('roles_creation'); 
    $builder->select('id, first_name,role');
    $builder->where('role','2');
    
    $query = $builder->get();
    $role = $query->getResultArray();

    if ($role) {
        return $this->response->setJSON($role);
    } else {
        return $this->response->setJSON(['result' => 0, 'message' => 'No roles found']);
    }
}
public function fetch_supervisor() {
    $db = \Config\Database::connect();
    $builder = $db->table('roles_creation'); 
    $builder->select('id, first_name,role');
    $builder->where('role', '3');
    $query = $builder->get();
    $role = $query->getResultArray();

    if ($role) {
        return $this->response->setJSON($role);
    } else {
        return $this->response->setJSON(['result' => 0, 'message' => 'No roles found']);
    }
}

public function checkNameExists()
{
    $selectedRole = $this->request->getPost('selectedRole'); 
    $db = \Config\Database::connect();
    $builder = $db->table('roles_creation');

  
    $builder->select('id,first_name');
    $builder->like('first_name', $selectedRole, 'after'); 
    $builder->orderBy('id', 'DESC');  
    $builder->limit(1);  

    $query = $builder->get();
    $result = $query->getRowArray(); 


    return $this->response->setJSON($result);
}

















}

?>